/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMVendorShell.hh,v $
// $Revision: 1.7 $
// $State: Exp $
// $Author: kseethar $
// $Date: 89/12/14 11:13:07 $
// $Locker:  $
//
// $Log:	XMVendorShell.hh,v $
Revision 1.7  89/12/14  11:13:07  kseethar
added vendorshell functions, KS

Revision 1.6  89/12/07  10:01:49  grlcr
*** empty log message ***

Revision 1.5  89/11/27  19:03:54  bmontagu
test

Revision 1.4  89/11/27  11:58:14  grlcr
1st pass

Revision 1.3  89/11/17  13:42:33  kseethar
*** empty log message ***

Revision 1.2  89/11/03  09:52:17  grlcr
*** empty log message ***

Revision 1.1  89/11/02  12:47:29  motifplb
Initial revision

// ***** Created Oct 11, 1989 by BRM *****
//-----------------------------------------------------------------------------
*/

#ifndef XMVendorShell_hh
#define XMVendorShell_hh

#include "XMWMShell.hh"
#include <Xm/Protocols.h>
#include <Xm/VendorE.h>

/* added by KS, Dec 14, 1989 from X11/Vendor.h */

/* DeleteResponse values */
#define XmDESTROY 	0
#define XmUNMAP 	1
#define XmDO_NOTHING	2

#define XmNdeleteResponse	"deleteResponse"
#define XmCDeleteResponse	"DeleteResponse"
#define XmRDeleteResponse	"DeleteResponse"

#define XtNkeyboardFocusPolicy   "keyboardFocusPolicy"
#define XtCKeyboardFocusPolicy   "KeyboardFocusPolicy"
#define XtRKeyboardFocusPolicy   "KeyboardFocusPolicy"

#define XtNfocusPolicyChanged	 "focusPolicyChanged"

#define XtNshellUnitType		"shellUnitType"
#define XtCShellUnitType		"ShellUnitType"
#define XtRShellUnitType		"ShellUnitType"

#define XmNkeyboardFocusPolicy   "keyboardFocusPolicy"
#define XmCKeyboardFocusPolicy   "KeyboardFocusPolicy"
#define XmRKeyboardFocusPolicy   "KeyboardFocusPolicy"

#define XmNfocusPolicyChanged	 "focusPolicyChanged"

#define XmNshellUnitType		"shellUnitType"
#define XmCShellUnitType		"ShellUnitType"
#define XmRShellUnitType		"ShellUnitType"

#define XmEXPLICIT 0 
#define XmPOINTER 1 

#define XmNmwmDecorations		"mwmDecorations"
#define XmCMwmDecorations		"MwmDecorations"
#define XmNmwmFunctions			"mwmFunctions"
#define XmCMwmFunctions			"MwmFunctions"
#define XmNmwmInputMode			"mwmInputMode"
#define XmCMwmInputMode			"MwmInputMode"
#define XmNmwmMenu			"mwmMenu"
#define XmCMwmMenu			"MwmMenu"
#define XmNmwmMessages			"mwmMessages"
#define XmCMwmMessages			"MwmMessages"

class XMVendorShell : public XMWMShell {
 protected:
     // ****CONSTRUCTORS**** 
     XMVendorShell ();

 public :
     // ****DESTRUCTOR****
     ~XMVendorShell ();

     // ****METHODS TO SET THE VendorShell RESOURCES****
     void set_deleteResponse      (u_char);
     void set_keyboardFocusPolicy (u_char);
     void set_mwmDecorations      (int);
     void set_mwmFunctions        (int);
     void set_mwmInputMode        (int);
     void set_mwmMenu             (String);
     void set_shellUnitType       (u_char);

     // ****METHODS TO GET THE VendorShell RESOURCES****
     void get_deleteResponse      (u_char*);
     void get_keyboardFocusPolicy (u_char*);
     void get_mwmDecorations      (int*);
     void get_mwmFunctions        (int*);
     void get_mwmInputMode        (int*);
     void get_mwmMenu             (String*);
     void get_shellUnitType       (u_char*);

     // ****Other Functions****
     
     void ActivateProtocol         (Atom, Atom);
     void ActivateWMProtocol       (Atom);
     void AddProtocolCallback      (Atom, Atom, XtCallbackProc, caddr_t); 
     void AddProtocols             (Atom, Atom*, Cardinal);
     void AddTabGroup              ();
     void AddWMProtocolCallback    (Atom, XtCallbackProc, caddr_t);
     void AddWMProtocols           (Atom*, Cardinal);
     void DeactivateProtocol       (Atom, Atom);
     void DeactivateWMProtocol     (Atom);
     void RemoveProtocolCallback   (Atom, Atom, XtCallbackProc, caddr_t);
     void RemoveProtocols          (Atom, Atom*, Cardinal);
     void RemoveWMProtocolCallback (Atom, XtCallbackProc, caddr_t);
     void RemoveWMProtocols        (Atom*, Cardinal);
     void SetWMProtocolHooks       (Atom, XtCallbackProc, XtCallbackProc, caddr_t, caddr_t);
     void SetProtocolHooks         (Atom, Atom, XtCallbackProc, XtCallbackProc, caddr_t, caddr_t);
};

#endif     // XMVendorShell_hh

// dont add stuff after this endif



